;www.boolean.name
;Nex, RBK
; -----------------------------------------------------------------------------
Global server,tstream

Global EOL$ = Chr$ (13)+Chr$ (13)+Chr$ (10)
Global ContentType$

Global request$, FileName$, FileFormat$, Protocol$, Parametrs$

Type Connection

	Field stream

End Type

; -----------------------------------------------------------------------------
;  ... HTTP ( 80)
; -----------------------------------------------------------------------------

CreateServer (80)

ChangeDir CurrentDir$() + "\WWW"

While Not KeyHit (1)

	UpdateServer ()

Wend

	DeleteServer ()

End 



Function CreateServer (port%)
	
server = CreateTCPServer (port)

If Not server Then RuntimeError "Server not created!"

End Function 

Function UpdateServer ()
tstream = AcceptTCPStream (server)
	If tstream Then 
			c.connection = New connection
				c\stream = tstream
				
			Delay 100

			For c.connection = Each connection
				If Not Eof (c\stream) Then 
					If ReadAvail (c\stream) Then
						msg$ = ReadLine (c\stream)
							If Left (msg$,3) = "GET" Then
								RequesParser (msg$)
									If FileName$ = "HTTP/1" Then
										FileName$ = "index"
										FileFormat$ = "html"
									EndIf 
									
								DebugLog request+" | "+FileName+" | "+FileFormat+" | "+Protocol+" | "+Parametrs$

								Select FileFormat$
									Case "ico"
										ContentType$ = "image/ico"
										
										file = ReadFile (CurrentDir$ ()+FileName$+"."+FileFormat$)
											If file Then
												FileLength = FileSize (CurrentDir$ ()+FileName$+"."+FileFormat$)
												BuildRequestHeader (c\stream,FileLength, ContentType$)
												
												bank1 = CreateBank(FileLength)

												ReadBytes(bank1, file, 0, FileLength)
												WriteBytes(bank1, c\stream, 0, FileLength)
												
												FreeBank bank1
												
											Else
												ErrorPage (c\stream)
											EndIf
									Case "png"
										ContentType$ = "image/png"

										file = ReadFile (CurrentDir$ ()+FileName$+"."+FileFormat$)
											If file Then
												FileLength = FileSize (CurrentDir$ ()+FileName$+"."+FileFormat$)
												BuildRequestHeader (c\stream,FileLength, ContentType$)
												
												bank1 = CreateBank(FileLength)

												ReadBytes(bank1, file, 0, FileLength)
												WriteBytes(bank1, c\stream, 0, FileLength)
												
												FreeBank bank1
												
											Else
												ErrorPage (c\stream)
											EndIf 
									Case "gif"
										ContentType$ = "image/gif"
										
										file = ReadFile (CurrentDir$ ()+FileName$+"."+FileFormat$)
											If file Then
												FileLength = FileSize (CurrentDir$ ()+FileName$+"."+FileFormat$)
												BuildRequestHeader (c\stream,FileLength, ContentType$)
												
												bank1 = CreateBank(FileLength)

												ReadBytes(bank1, file, 0, FileLength)
												WriteBytes(bank1, c\stream, 0, FileLength)
												
												FreeBank bank1
												
											Else
												ErrorPage (c\stream)
											EndIf
									Case "jpg"
										ContentType$ = "image/jpeg"
										
										file = ReadFile (CurrentDir$ ()+FileName$+"."+FileFormat$)
											If file Then
												FileLength = FileSize (CurrentDir$ ()+FileName$+"."+FileFormat$)
												BuildRequestHeader (c\stream,FileLength, ContentType$)
												
												bank1 = CreateBank(FileLength)

												ReadBytes(bank1, file, 0, FileLength)
												WriteBytes(bank1, c\stream, 0, FileLength)
												
												FreeBank bank1
												
											Else
												ErrorPage (c\stream)
											EndIf 
											
									Case "txt"
										ContentType$ = "text/plain"
									Case "zip"
										ContentType$ = "application/zip"
									Case "html"
										ContentType$ = "text/html"
										
										
										If Parametrs$ = "?cod=987654321" 
											FileName$ = "key/jpg"
										ElseIf Parametrs$ <> ""
											FileName$ = "key/kod"
										End If
											
										file = ReadFile (CurrentDir$ ()+FileName$+"."+FileFormat$)
											If file Then
												FileLength = FileSize (CurrentDir$ ()+FileName$+"."+FileFormat$)
												BuildRequestHeader (c\stream,FileLength, ContentType$)
											
												While Not Eof (file)
													dat$ = ReadLine (file)
														WriteLine (c\stream,dat$)
												Wend
											Else
												ErrorPage (c\stream)
											EndIf

									Default
										ErrorPage (c\stream)
								End Select
							EndIf
						DebugLog msg
						DebugLog("------------------------------------------------------------------------------")
					EndIf
				Else
					DebugLog("")
					DebugLog("---------<CLOSE>--------------------------------------")
					DebugLog("")

					CloseTCPStream c\stream
					Delete c
				EndIf
			Next
	EndIf
End Function 

Function ErrorPage (client)
	file = ReadFile ("error.html")
		If file Then
			FileLength = FileSize ("error.html")
			BuildRequestHeader (client,FileLength,"text/html")
												
			While Not Eof (file)
				dat$ = ReadLine (file)
					WriteLine (client,dat$)
			Wend
		EndIf 
End Function 
; ---------------------------------------------------
; File format
; ---------------------------------------------------

Function DeleteServer ()
	For c.Connection = Each Connection
		CloseTCPStream c\stream
		Delete c
	Next
	
	CloseTCPServer server
End Function 

Function RequesParser (msg$)
	message$ = msg$
	message$ = Replace (message$," ","")
	
	If message$ >"" Then
		request$ = Mid$ (message$,1,Instr (message,"/")-1)
			message$ =Replace (message$,Mid (message$,1,Len (request)+1),"")
		FileName$ = Mid$ (message$,1,Instr (message$,".")-1)
			message$ = Replace (message$,Mid (message$,1,Len (FileName)+1),"")
		FileFormat$ = Mid$ (message$,1,Instr (message$,"H")-1)
			message$ = Replace (message$,Mid (message$,1,Len (FileFormat)),"")
		Protocol$ = message$
	EndIf 
	
	If Instr(FileFormat$, "?") <> 0
		message$ = FileFormat$
		FileFormat$ = Mid$ (message$,1,Instr (message$,"?")-1)
			message$ = Replace (message$,Mid (message$,1,Len (FileFormat)),"")
		Parametrs$ = message$
	Else
		Parametrs$ = ""
	End If

End Function 

Function BuildRequestHeader (client,DataLength, ContentType$)
	WriteLine (client,"HTTP/1.0 200 OK")	
	WriteLine (client,"Server: Blitzzz")
	WriteLine (client,"Content-Length: "+Str (DataLength))
	WriteLine (client,"Content-Type: "+ContentType$)
	WriteLine (client,EOL$)
End Function 